renoise.tool():add_keybinding {
  name = "Global:Tools:Set Track Width To Active Columns",
  invoke = function()set_track_to_active_columns()
  end  
}

renoise.tool():add_menu_entry {
  name = "Pattern Editor:Set Track Width To Active Columns",
  invoke = function() set_track_to_active_columns()
  end
}


function set_track_to_active_columns()

--renoise.app():show_status("`Set Track To Active Columns` Tool : (Busy...)")

local pattern_index = renoise.song().selected_pattern_index
local track_index = renoise.song().selected_track_index
local pattern_length = renoise.song().patterns[pattern_index].number_of_lines
local all_patterns = #renoise.song().patterns

--currently selected track--
local current_pattern_track = renoise.song().patterns[pattern_index].tracks[track_index] 
local found_pattern
local found_pattern_shown_number
local column_adjusted_to


---line_index `iterate` 
local note_found = false

for note_col = 12,1,-1 do --each column starting from 12

  renoise.app():show_status("`Set Track To Active Columns` Tool: (Checking Column in Song: ".. note_col..")")

  if note_found == true then
    break
  end

  for pattern = 1, all_patterns do --each pattern
   
    
    if note_found == true then
      break
    end 
    
   
  
    current_pattern_track = renoise.song().patterns[pattern].tracks[track_index]
    for line_index = 1, pattern_length do  --each cell
    
     
     
      local note_columns = current_pattern_track:line(line_index).note_columns --table
   
      if note_columns[note_col].note_value < 120 then --(120 = note-off, 121 = empty)
        note_found = true
        found_pattern = (pattern)
        --set visible columns
        renoise.song().tracks[track_index].visible_note_columns = note_col
        column_adjusted_to = note_col
        break
      end

       
  
    end --for line_index
  end --for pattern      





end --for note_col


--status

if found_pattern then
  renoise.app():show_status("`Set Track To Active Columns` Tool : (Completed.  Right-Most Note found in:  Column: "..column_adjusted_to.." / Pattern: "..(found_pattern - 1)..")")
else
 renoise.song().tracks[track_index].visible_note_columns = 1 --set columns
 renoise.app():show_status("`Set Track To Active Columns` Tool : (Completed.  Set To 1 Column , No Notes Were Found)")
end
  
end --main



















